// GnlPpsEvntPvdr.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f GnlPpsEvntPvdrps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "GnlPpsEvntPvdr.h"

#include "GnlPpsEvntPvdr_i.c"
#include "Wep.h"
#include "Gpep.h"


CComModule _Module;

WSADATA _oWsaData = {0};
IWbemServicesPtr _spNamespace;
IWbemClassObjectPtr	_spEventClassDef;
IWbemObjectSinkPtr _spSink;
INT _eWepStatus;
HANDLE _hThread;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_Wep, CWep)
OBJECT_ENTRY(CLSID_Gpep, CGpep)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH) {	
   		if (!_Module.GetLockCount()) {  
			// when first process attaches initialize globals
			
			// initialize the use of Ws2_32.dll by a process
			INT ir = WSAStartup(MAKEWORD(1, 1), &_oWsaData);
			if (ir) throw;  // TODO: comment out throw for vs.net build support

			// _eWepStatus = Pending;
		}

		// _Module.Init(ObjectMap, hInstance, &LIBID_GNLPPSEVNTPVDRLib);
		_Module.Init(ObjectMap, hInstance, &LIBID_GnlPpsEvntPvdr);
        DisableThreadLibraryCalls(hInstance);
		#if (_DEBUG)
			INT iLockCount = _Module.GetLockCount();
		#endif
    }
    else {
		if (dwReason == DLL_PROCESS_DETACH) {
			if (!_Module.GetLockCount()) { 
			// when last process detaches uninitialize globals
			
			// uninitialize the use of Ws2_32.dll by a process
			INT ir = WSACleanup();
			if (ir) throw;  // TODO: comment out throw for vs.net build support

			// _eWepStatus = Stopped;
			}
		}

        _Module.Term();
	}

    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	#if (_DEBUG)
		INT iLockCount = _Module.GetLockCount();
	#endif

    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
	/*
	if (_Module.GetLockCount())
		return S_FALSE;
	else {
		_eWepStatus = PendingStop;
		return S_OK;
	}
	*/
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	#if (_DEBUG)
		INT iLockCount = _Module.GetLockCount();
	#endif
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}


HRESULT OutputDebugStringEx(HRESULT hrError, BSTR bsRoutine)
{
	// purpose = extract a string representation of HRESULT and send to output window to support debugging
	// on NDEBUG builds function does nothing
	HRESULT hr = S_OK;

#if defined(_DEBUG)
	LPTSTR pgzTemp = NULL;

	try {
		// validate parameters
		if (/* !hrErrorInfo || */ !bsRoutine || !SysStringLen(bsRoutine)) { hr = E_INVALIDARG; throw hr; }

		DWORD dwr = FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_FROM_SYSTEM,
								  NULL, hrError, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&pgzTemp, 0, NULL);
		if (!dwr && (ERROR_MR_MID_NOT_FOUND != GetLastError())) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }
		_bstr_t sTemp;
		sTemp = _T("Error processing \"");
		sTemp += bsRoutine;
		sTemp += _T("\" resulting in a FormatMessage description = ");
		if (pgzTemp && _tcslen(pgzTemp))
			sTemp += pgzTemp;
		else
			sTemp += _T("message not found");
		OutputDebugString(sTemp);
	}
	
	catch(...) {
		// do nothing in the case of a expected exceptions for this function
		if (SUCCEEDED(hr)) throw;  // pass unexpected exceptions on to the outer block
	}

	IErrorInfo *pErrorInfo = NULL;
	HANDLE hHeap = GetProcessHeap();
	if (!hHeap || (INVALID_HANDLE_VALUE == hHeap)) throw;
	BOOL br = HeapFree(hHeap, 0, pgzTemp);
	if (!br) throw;
	pgzTemp = NULL;
#endif

	return hr;
}



