// Gpep.cpp : Implementation of CGpep
#include "stdafx.h"
#include "GnlPpsEvntPvdr.h"
#include "Gpep.h"

/////////////////////////////////////////////////////////////////////////////
// CGpep


STDMETHODIMP CGpep::Fire(BSTR bsApplication, BSTR bsUser, INT iNumberValue, BSTR bsStringValue, VARIANT vHostname, VARIANT vCreationDate, VARIANT vTerminationDate)
{
	HRESULT hr = S_OK;
	try {
		// validate parameters
		if (!bsApplication || !SysStringLen(bsApplication) ||
			!bsUser || !SysStringLen(bsUser) ||
			/* !iNumberValue || */
			!bsStringValue || !SysStringLen(bsStringValue) // || 
			/* !vHostname || !vCreationDate || !vTerminationDate */) { hr = E_INVALIDARG; throw hr; }

		// now check to see if any consumers have registered to receive the general purpose event provider events and if
		// not just exit right away in the interest of efficiency
		// TODO: select an better wbem hresult code to return or define a custom one for this case
		if (Running != _eWepStatus /* || NULL == _spEventClassDef || NULL == _spSink */) { /* hr = E_FAIL; */ throw hr; }

		// spawn an instance of the event object
		IWbemClassObject *pEvent = 0;
		//IWbemClassObjectPtr spEvent;        
		
		hr = _spEventClassDef->SpawnInstance(0, &pEvent);
		//hr = m_spEventClassDef->SpawnInstance(0, &spEvent);
		if (FAILED(hr)) throw hr;

		// note - [optionally] use an instance provider to create an instance of a GpepApplication class and submit that
		// as an event class TargetInstance object property therefore matching the behavior of most wmi intrinsic events

		// use the passed values to populate the event
		_variant_t vTemp(bsApplication);
		hr = pEvent->Put(_T("Application"), 0, &vTemp, 0);
		//hr = pEvent->Put(_T("Application"), 0, &vTemp, VT_BSTR);
		//hr = spEvent->Put(_T("Application"), 0, &vTemp, VT_BSTR);
		if (FAILED(hr)) throw hr;

		vTemp.Clear();
		vTemp = bsUser;
		hr = pEvent->Put(_T("User"), 0, &vTemp, 0);
		//hr = pEvent->Put(_T("User"), 0, &vTemp, VT_BSTR);
		//hr = spEvent->Put(_T("User"), 0, &vTemp, VT_BSTR);
		if (FAILED(hr)) throw hr;

		vTemp.Clear(); 
		vTemp = (LONG)iNumberValue;
		hr = pEvent->Put(_T("NumberValue"), 0, &vTemp, 0);
		//hr = pEvent->Put(_T("NumberValue"), 0, &vTemp, VT_I4);
		//hr = spEvent->Put(_T("NumberValue"), 0, &vTemp, VT_I4);
		if (FAILED(hr)) throw hr;

		vTemp.Clear();
		vTemp = bsStringValue;
		hr = pEvent->Put(_T("StringValue"), 0, &vTemp, 0);
		//hr = pEvent->Put(_T("StringValue"), 0, &vTemp, VT_BSTR);
		//hr = spEvent->Put(_T("StringValue"), 0, &vTemp, VT_BSTR);
		if (FAILED(hr)) throw hr;

		// note - VT_ERROR == <parameters>.vt results from optional automation method argument left blank
		if (VT_ERROR != vHostname.vt) {
			/*
			hr = pEvent->Put(_T("Hostname"), 0, &vHostname, 0);
			//hr = pEvent->Put(_T("Hostname"), 0, &vHostname, VT_BSTR);
			//hr = spEvent->Put(_T("Hostname"), 0, &vHostname, VT_BSTR);
			if (FAILED(hr)) throw hr;
			*/
			// note - when vb apps calls with component referenced As Object then instead of variant being VT_BSTR it
			// is passed as VT_VARIANT|VT_BYREF resulting in error of -2147217403/ 0x80041005 = type mismatch when the
			// Put method is called, therefore we will force a conversion here in all cases before calling Put to 
			// ensure the error does not occur
			vTemp.Clear();
			vTemp = vHostname;
			vTemp.ChangeType(VT_BSTR, NULL);
			hr = pEvent->Put(_T("Hostname"), 0, &vTemp, 0);
			if (FAILED(hr)) throw hr;
		}

		#if defined(_DEBUG)
			INT iTest = 0;
			if (VT_ERROR != vCreationDate.vt) {
				if (VT_BSTR == vCreationDate.vt)
					iTest = _tcslen(vCreationDate.bstrVal);
				if ((VT_VARIANT | VT_BYREF) == vCreationDate.vt)
					iTest = _tcslen(vCreationDate.pvarVal->bstrVal);
			}
			iTest = 0;
			if (VT_ERROR != vTerminationDate.vt) {
				if (VT_BSTR == vTerminationDate.vt)
					iTest = _tcslen(vTerminationDate.bstrVal);
				if ((VT_VARIANT | VT_BYREF) == vTerminationDate.vt)
					iTest = _tcslen(vTerminationDate.pvarVal->bstrVal);
			}
		#endif

		if ((VT_ERROR != vCreationDate.vt) /* && _tcslen(vCreationDate.bstrVal) */) {
			/*
			hr = pEvent->Put(_T("CreationDate"), 0, &vCreationDate, 0);
			//hr = pEvent->Put(_T("CreationDate"), 0, &vCreationDate, VT_BSTR);
			//hr = spEvent->Put(_T("CreationDate"), 0, &vCreationDate, VT_BSTR);
			if (FAILED(hr)) throw hr;
			*/
			// note - when vb apps calls with component referenced As Object then instead of variant being VT_BSTR it
			// is passed as VT_VARIANT|VT_BYREF resulting in error of -2147217403/ 0x80041005 = type mismatch when the
			// Put method is called, therefore we will force a conversion here in all cases before calling Put to 
			// ensure the error does not occur
			vTemp.Clear();
			vTemp = vCreationDate;
			vTemp.ChangeType(VT_BSTR, NULL);
			hr = pEvent->Put(_T("CreationDate"), 0, &vTemp, 0);
			if (FAILED(hr)) throw hr;
		}

		if ((VT_ERROR != vTerminationDate.vt) /* && _tcslen(vTerminationDate.bstrVal) */) {
			/*
			hr = pEvent->Put(_T("TerminationDate"), 0, &vTerminationDate, 0);
			//hr = pEvent->Put(_T("TerminationDate"), 0, &vTerminationDate, VT_BSTR);
			//hr = spEvent->Put(_T("TerminationDate"), 0, &vTerminationDate, VT_BSTR);
			if (FAILED(hr)) throw hr;
			*/
			// note - when vb apps calls with component referenced As Object then instead of variant being VT_BSTR it
			// is passed as VT_VARIANT|VT_BYREF resulting in error of -2147217403/ 0x80041005 = type mismatch when the
			// Put method is called, therefore we will force a conversion here in all cases before calling Put to 
			// ensure the error does not occur
			vTemp.Clear();
			vTemp = vTerminationDate;
			vTemp.ChangeType(VT_BSTR, NULL);
			hr = pEvent->Put(_T("TerminationDate"), 0, &vTemp, 0);
			if (FAILED(hr)) throw hr;
		}

		// deliver the event to CIMOM
		hr = _spSink->Indicate(1, &pEvent);
		//hr = m_spSink->Indicate(1, &spEvent);
		if (FAILED(hr)) { /* throw hr; */ /* if here, delivery failed.  Do something to report it */ }
		// -2147217402/0x80041006 == WBEM_E_OUT_OF_MEMORY

		pEvent->Release();
		// if (pEvent) pEvent->Release(); need a catch for this when throws occur ???
	}

	catch(...) {
		OutputDebugStringEx(hr, _bstr_t(_T("Fire")));
		// if (SUCCEEDED(hr)) throw;  // [optionally] pass unexpected exceptions on to the outer block
	}
    
	return hr;
}


STDMETHODIMP CGpep::CurrentWmiDateTime(BSTR *pbsWmiDateTime)
{
	HRESULT hr = S_OK;

	try {
		// validate parameters
		if (!pbsWmiDateTime) { hr = E_INVALIDARG; throw hr; }

		/*
		SYSTEMTIME oSystemTime = {0};
		GetSystemTime(&oSystemTime);  // this returns gmt or utc offset of 0
		if (0 == oSystemTime.wYear) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }
		*/

		FILETIME oFileTime = {0};
		GetSystemTimeAsFileTime(&oFileTime);  // this returns gmt or utc offset of 0
		if (0 == oFileTime.dwLowDateTime /* || 0 == oFileTime.dwHighDateTime */) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }

		FILETIME oLocalFileTime = {0};
		BOOL br = FileTimeToLocalFileTime(&oFileTime,  // UTC file time to convert
										  &oLocalFileTime);  // converted file time
		if (!br) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }
	
		SYSTEMTIME oLocalSystemTime = {0};
		br = FileTimeToSystemTime(&oLocalFileTime,  // file time to convert
								  &oLocalSystemTime);  // receives system time
		if (!br) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }

		// now convert local systemtime structure to wmi datetime format = yyyymmddHHMMSS.mmmmmmsUUU
		// where mmmmmm = six digit representation of microseconds
		//		 s = + | - offset from UTC (GMT has UTC offset of 0)
		//		 UUU = three digit representation of the number of minutes that originating time zone deviates from UTC
		_TCHAR gzTemp[10] = _T("000000\0");
		_bstr_t sWmiDateTime;

		_ltot(oLocalSystemTime.wYear, gzTemp, 10);
		sWmiDateTime = gzTemp;

		if (10 > oLocalSystemTime.wMonth) sWmiDateTime += _T("0");
		_ltot(oLocalSystemTime.wMonth, gzTemp, 10);
		sWmiDateTime += gzTemp;

		if (10 > oLocalSystemTime.wDay) sWmiDateTime += _T("0");
		_ltot(oLocalSystemTime.wDay, gzTemp, 10);
		sWmiDateTime += gzTemp;

		if (10 > oLocalSystemTime.wHour) sWmiDateTime += _T("0");
		_ltot(oLocalSystemTime.wHour, gzTemp, 10);
		sWmiDateTime += gzTemp;

		if (10 > oLocalSystemTime.wMinute) sWmiDateTime += _T("0");
		_ltot(oLocalSystemTime.wMinute, gzTemp, 10);
		sWmiDateTime += gzTemp;

		if (10 > oLocalSystemTime.wSecond) sWmiDateTime += _T("0");
		_ltot(oLocalSystemTime.wSecond, gzTemp, 10);
		sWmiDateTime += gzTemp;

		sWmiDateTime += _T(".");

		LONG lTemp = oLocalSystemTime.wMilliseconds * 1000;
		for (INT iPow = 1; iPow < 6; iPow++)
			if (pow(10, iPow) > lTemp) sWmiDateTime += _T("0");
		_ltot(lTemp, gzTemp, 10);
		sWmiDateTime += gzTemp;

		TIME_ZONE_INFORMATION oTimeZoneInfo = {0};
		DWORD dwr = GetTimeZoneInformation(&oTimeZoneInfo);
		if (TIME_ZONE_ID_INVALID == dwr) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }

		lTemp = oTimeZoneInfo.Bias;
		if (0 > lTemp) {  // the offset result signs are opposite what you might expect
			lTemp *= -1;
			sWmiDateTime += "+";
		}
		else {
			sWmiDateTime += "-";
		}
		if (10 > lTemp) sWmiDateTime += _T("0");
		if (100 > lTemp) sWmiDateTime += _T("0");
		_ltot(lTemp, gzTemp, 10);
		sWmiDateTime += gzTemp;

		*pbsWmiDateTime = SysAllocString(sWmiDateTime);
	}

	catch(...) {
		OutputDebugStringEx(hr, _bstr_t(_T("CurrentWmiDateTime")));
		// if (SUCCEEDED(hr)) throw;  // [optionally] pass unexpected exceptions on to the outer block
	}
    
	return hr;
}

STDMETHODIMP CGpep::LocalHostname(BSTR *pbsHostname)
{
	HRESULT hr = S_OK;
	try {
			// winsock method for acquiring dns host name, does not support generic text
			/*
			// note - see DllMain for winsock data structure startup call
			WSADATA oWsaData = {0};
			INT ir = WSAStartup(MAKEWORD(1, 1), &oWsaData);
			if (ir) { hr = HRESULT_FROM_WIN32(WSAGetLastError()); throw hr; }
			*/
			char szTemp[MAX_HOSTNAME] = "\0";
			INT ccTemp = MAX_HOSTNAME;
			INT ir = gethostname(szTemp, ccTemp);
			if (ir) { hr = HRESULT_FROM_WIN32(WSAGetLastError()); throw hr; }
			_bstr_t sHostname(szTemp);
			/*
			// note - see DllMain for winsock data structure cleanup call
			ir = WSACleanup();
			if (ir) { hr = HRESULT_FROM_WIN32(WSAGetLastError()); throw hr; }
			*/

			/*
			// psdk method for acquring dns hostname, supports generic text but isn't recognized by compiler ???
			_TCHAR gzTemp[MAX_HOSTNAME] = _T("\0");
			#if defined(_DEBUG)
				ccTemp = MAX_HOSTNAME;
			#else
				INT ccTemp = MAX_HOSTNAME;
			#endif
			BOOL br = GetComputerNameEx(ComputerNameDnsDomaineType, // name type
										gzTemp,  // name buffer
										&ccTemp);  // count of characters in buffer
			if (!br) { hr = HRESULT_FROM_WIN32(GetLastError()); throw hr; }
			_bstr_t sHostname(szTemp);
			*/

			*pbsHostname = SysAllocString(sHostname);
	}

	catch(...) {
		OutputDebugStringEx(hr, _bstr_t(_T("CurrentWmiDateTime")));
		// if (SUCCEEDED(hr)) throw;  // [optionally] pass unexpected exceptions on to the outer block
	}
    
	return hr;
}
