// Wep.h : Declaration of the CWep

#ifndef __WEP_H_
#define __WEP_H_

#include "resource.h"       // main symbols
#include "StdAfx.h"	// Added by ClassView

/////////////////////////////////////////////////////////////////////////////
// CWep
class ATL_NO_VTABLE CWep : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CWep, &CLSID_Wep>,
	public IWep,
	public IWbemProviderInit,
	public IWbemEventProvider
	// note - see msdn / contents / psdk / mgmtSvcs / wmi / wmiAppProg / eventNotfication / implementingAnEventProvider
	// for details on "Typically, the provider will implement a COM object using multiple inheritance to support both the
	// IWbemProviderInit interface as well as its primary interface, such as IWbemServices or IWbemEventProvider."
{
public:
	CWep() {
		// initialize instance member variables
		_eWepStatus = Pending;
		_hThread = 0;
	}

	~CWep() {
		// uninitialize instance member variables
		if (_hThread) { CloseHandle(_hThread); _hThread = 0; }
		_eWepStatus = PendingStop;
		if (_spSink) _spSink.Release();
		if (_spEventClassDef) _spEventClassDef.Release();
		if (_spNamespace) _spNamespace.Release();
	}

DECLARE_REGISTRY_RESOURCEID(IDR_WEP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWep)
	COM_INTERFACE_ENTRY(IWep)	
	COM_INTERFACE_ENTRY(IWbemProviderInit)
	COM_INTERFACE_ENTRY(IWbemEventProvider)
END_COM_MAP()

// IWep
public:
	// psdk sample local event generation thread procedures
	STDMETHOD(InstanceThread)(/*[in]*/ BSTR bsApplication, /*[in]*/ BSTR bsUser, /*[in]*/ INT iNumberValue, /*[in]*/ BSTR bsStringValue, /*[in]*/ VARIANT vHostname, /*[in]*/ VARIANT vCreationDate, /*[in]*/ VARIANT vTerminationDate);

	// note - defining threadproc as a class method even if defined and called as a static versus instance method 
	// doesn't want to cast properly so we will define and call the threadproc as a standard winapi function
	// STDMETHOD(EventThread)(/*[in]*/ /* LPVOID */ LONG *pArg);

	// inherited from IWbemEventProvider
	STDMETHOD(ProvideEvents)(/*[in]*/ IWbemObjectSink *pSink, /*[in]*/ long lFlags);

	// inherited from IWbemProviderInit
	STDMETHOD(Initialize)(/*[in]*/ LPWSTR wszUser, /*[in]*/  LONG lFlags, /*[in]*/ LPWSTR wszNamespace, /*[in]*/ LPWSTR wszLocale, /*[in]*/ IWbemServices *pNamespace, /*[in]*/ IWbemContext *pCtx, /*[in]*/ IWbemProviderInitSink *pInitSink);

private:
	/*
	typedef enum _WEPSTATUS { Pending, Running, PendingStop, Stopped } WEPSTATUS;
	IWbemServicesPtr m_spNamespace;
	IWbemClassObjectPtr	m_spEventClassDef;
	IWbemObjectSinkPtr m_spSink;
	INT	m_eWepStatus;
	HANDLE m_hThread;
	*/
};

// define and call the threadproc as a standard winapi function
UINT WINAPI EventThread(LPVOID pArg);

#endif //__WEP_H_
